#include "common.hpp"
#include "array.hpp"
#include "action.hpp"

using namespace std::complex_literals;

template <typename Scalar, typename Shape>
void dump(Array<Scalar,Shape> Q)
#if 1
{
    for (size_t i = 0; i < Q.dim(0); ++i) {
        for (size_t j = 0; j < Q.dim(1); ++j) {
            for (size_t k = 0; k < Q.dim(2); ++k) {
                std::cout << i << "," << j << "," << k << " = " << Q(i,j,k) << std::endl;
            }
        }
    }

    for (size_t i = 0; i < Q.data().size(); ++i) {
        std::cout << Q.data()[i] << std::endl;
    }
}
#else
;
#endif

int main()
{
    std::vector<double> v(2*2*2);
    Array<double,Shape<Dynamic,2,2> > Q0(v,{2,2,2});
    auto Q = Q0.part(0u);

    S_2(Q);

    dump(Q0);

    auto mat = Q.matrix();

    mat = mat * mat * mat;

    if constexpr(true) {
    }

    dump(Q0);

    return 0;
}
